let addn m n = m + n

let add_one m = addn 1

let add_two m = addn 2

let rec f m = 
  if m=0 
  then [] 
  else (addn m)::(f (m-1))

let rec map f lst =
  match lst with
    []     -> []
  | hd::tl -> (f hd)::(map f tl)

(* just a function pointer *)
let incr lst = map (fun x -> x+1) lst
let incr = map (fun x -> x+1)
(* a closure *)
let mul i lst = map (fun x -> x*i) lst
let mul i = map (fun x -> x*i)

let rec fold_left f acc lst =
  match lst with
    []     -> acc
  | hd::tl -> fold_left f (f acc hd) tl

(* just function pointers *)
let f1 = fold_left (fun x y -> x+y) 0
let f2 = fold_left (fun x y -> x && y>0) true
(* a closure *)
let f1 lst lo hi = 
 fold_left 
 (fun x y -> if y>lo && y<hi then x+1 else x)
 0
 lst

let f1 g h = (fun x -> g (h x))

type 'a option = None | Some of 'a (*predefined*)

let f2 g h x = 
  match g x with
    None   -> h x
  | Some y -> y

type set = { add : int -> set; member : int -> bool }

let empty_set = 
  let exists lst j = (*could use fold_left!*)
     let rec iter rest =
        match rest with 
          [] -> false 
        | hd::tl -> j=hd || iter tl in
     iter lst in
  let rec make_set lst = 
     { add    = (fun i -> make_set(i::lst));
       member = exists lst } in
  make_set []
